.model TINY 
.386 

.code 
org 7C00h
start: 
                    ; Erst brauchen wir einen Stack. 
    cli                ; Keine Interrupts! 
    mov ax, 9000h      ; Stackadresse 
    mov ss, ax      ; SS = 0x9000 (unser Stack) 
    mov sp, 0       ; SP = 0x0000  (der Stackpointer) 
    sti             ; Interrupts zulassen 
    
    ; Segmentregister initialisieren (f? Zugriff auf bootdrv notwendig) 
    mov ax, 0 
    mov es, ax 
    mov ds, ax 
    
    ; Bootlaufwerk aus DL speichern 
    mov [bootdrv], dl 
  
    ;Lade unseren Kernel 
    call load 
    
    mov ah,00h	;wait user press a key to jmp and load again
    int 16h
    
    ;Springe zu diesem Kernel 
    mov ax, 1000h ; Die Adresse des Programms 
    mov es, ax     ; Segmentregister updaten 
    mov ds, ax 
    push ds
    push 0
    retf

    bootdrv db 0 ;Das Bootlaufwerk 
    loadmsg db "Loading my O.S., press any key...",13,10,0 
    
    ; Einen String ausgeben: 
    putstr: 
    lodsb             ; Byte laden 
    or al,al 
    jz short putstrd  ; 0-Byte? -> Ende! 
  
    mov ah,0Eh        ; Funktion 0x0E 
    mov bx,0007h      ; Attribut-Byte (wird nicht ben?igt) 
    int 10h           ; schreiben 
    jmp putstr        ; N?hstes Byte 
    putstrd: 
    retn 
    
    ; Lade den Kernel vom Bootlaufwerk 
    load: 
    ; Diskdrive reset (Interrupt 13h, 0) 
    mov ax, 0          ; Die gew?schte Funktion (reset) 
    mov dl, [bootdrv]  ; Dieses Laufwerk ist gew?scht 
    int 13h            ; Den Interrupt ausf?ren 
    jc load            ; Geht nicht? -> Noch mal! 
  
    load1: 
    mov ax,1000h       ; ES:BX = 0x10000 
    mov es,ax 
    mov bx, 0 
  
    ; Sektoren lesen (Interrupt 13h, 2) 
    mov ah, 2         ; Funktion 2 (Lesen) 
    mov al, 5         ; Lese 5 Sektoren 
    mov cx, 2         ; Cylinder=0, Sector=2 
    mov dh, 0         ; Head=0 
    mov dl, [bootdrv] ; Laufwerk aus Vorgabe 
    int 13h           ; ES:BX =  Daten vom Laufwerk 
    jc load1          ; Fehler? Noch mal! 
    mov si, offset loadmsg 
    call putstr       ; Meldung ausgeben 
    retn 

org 7C00h + 510
dw 0AA55h                 ; Bootsignatur 


; ********************************** 
; ***********End Boot Loader******** 
; ********************************** 
END start

ml /c /AT bootl.Asm
link16 /tiny bootl.obj, boot.flp
A warning error while link16 is normal, since this program is not a .com, do not start at 100h
